#include "TxtLog.h"
#include <String.hpp>

TxtLog::~TxtLog()
{
	if( file )
	{
		fputs( "---------------------Loging stopped------------------------------\n", file );
		fclose( file ); file = 0;
	}
}

void TxtLog::warning(const String & str)
{
	if( file )
	{
		fprintf( file, "----Warning----: %s\n", str.c_str() );
		fflush( file );
	}
}

void TxtLog::message(const String & str)
{
	if( file )
	{
		fputs( str.c_str(), file );
		fflush( file );
	}
}
void TxtLog::error(const String & str)
{
	if( file )
	{
		fprintf( file, "-----Error-----: %s\n", str.c_str() );
		fflush( file );
	}
}

TxtLog::TxtLog(const String & fname, const String & header)
:	file( fopen( fname.c_str(), "wt" ) )
{
	if( file )
	{
		fputs( header.c_str(), file );
		fputs( "\n", file );
		fputs( "---------------------Loging started------------------------------\n", file );
		fflush( file );
	}
}
