#ifndef STRING_H
#define STRING_H

#include <string>

class String
{
	std::string data;
public:
	String()
	{}
	String(int n, char c)
	:	data( n, c )
	{}
	String(const char * str)
	:	data( str )
	{}
	String(const char * begin, const char * end)
	:	data( begin, end )
	{}
	String(const String & str)
	:	data( str.data )
	{}
	const String & operator=(const char * str)
	{
		data = str;
		return *this;
	}
	const String & operator=(const String & str)
	{
		data = str.data;
		return *this;
	}
/*	operator const char *()const
	{
		return data.c_str();
	}*/
	const char * c_str()const
	{
		return data.c_str();
	}
	unsigned size()const
	{
		return data.size();
	}
	void resize(unsigned new_size)
	{
		data.resize( new_size );
	}
	char operator[]( unsigned pos )const
	{
		if( pos >= data.size() ) // ஢ઠ ⭨ ६,    
			return 0;
		return data[ pos ];
	}
	bool empty()const
	{
		return data.size() == 0;
	}
	const String & operator+=(char c)
	{
		data += c;
		return *this;
	}
	const String & operator+=(const char * str)
	{
		data += str;
		return *this;
	}
	const String & operator+=(const String & str)
	{
		data += str.data;
		return *this;
	}
	int compare(const char * str)const
	{
		return data.compare( str );
	}
	int compare(const String & str)const
	{
		return data.compare( str.data );
	}
};

inline bool operator==(const String & a, const String & b)
{
	return a.compare( b ) == 0;
}
inline bool operator==(const char * a, const String & b)
{
	return b.compare( a ) == 0;
}
inline bool operator==(const String & a, const char * b)
{
	return a.compare( b ) == 0;
}

inline bool operator!=(const String & a, const String & b)
{
	return !operator==( a, b );
}
inline bool operator!=(const char * a, const String & b)
{
	return !operator==( a, b );
}
inline bool operator!=(const String & a, const char * b)
{
	return !operator==( a, b );
}

inline bool operator<(const String & a, const String & b)
{
	return a.compare( b ) < 0;
}
inline bool operator<(const char * a, const String & b)
{
	return b.compare( a ) > 0;
}
inline bool operator<(const String & a, const char * b)
{
	return a.compare( b ) < 0;
}

inline String operator+(const String & a, const String & b)
{
	return String(a) += b;
}
inline String operator+(const String & a, const char * b)
{
	return String(a) += b;
}
inline String operator+(const String & a, char b)
{
	return String(a) += b;
}

#endif //STRING_H